unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, clipbrd, ExtCtrls, Mask, ToolEdit;

type
  TForm1 = class(TForm)
    bSelect: TBitBtn;
    OpenDialog1: TOpenDialog;
    bStop: TBitBtn;
    bStart: TBitBtn;
    bCancel: TBitBtn;
    cDelay: TEdit;
    label1: TLabel;
    cGPSstring: TEdit;
    cNMEA: TRadioGroup;
    cFname: TEdit;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bSelectClick(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure bStartClick(Sender: TObject);
    procedure bCancelClick(Sender: TObject);
    procedure cNMEAClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    doPause:boolean;
    doCancel:boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  OziMessage:integer;
  GPSstring:string;
  hwnd1:HWND;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var hwnd1:HWND;
begin
// this procedure is run first
// this registers a windows message with the system
// OziExplorer knows this message is meant for it
OziMessage:= RegisterWindowMessage('OziExplorer');
hwnd1:= FindWindow('TfmMainform', nil);
If hwnd1 = 0
   Then begin
        Showmessage ('Please Start OziExplorer');
        end;
end;


procedure Delay(ms: LongInt);
VAR
  TickCount: LongInt;
Begin
  TickCount:= GetTickCount;
  While GetTickCount - TickCount < ms do application.processmessages; {see multi-tasking}
End;


FUNCTION Ltrim(tempstr:String):String;
{!!!!!!!!!trims any spaces on the left of a string!!!!!!!!!}
VAR i,J:INTEGER;
BEGIN
J:=Length(tempstr);
if j>0
   then begin
        i:=1;
        REPEAT
          IF tempstr[1]=' ' THEN Delete(tempstr,1,1);
          i:=i+1;
        UNTIL (Length(tempstr)=0) or (tempstr[1]<>' ') Or (i>J);
        end;
Ltrim:=tempstr;
END;    {end of trimleft}



FUNCTION Empty(s:String):BOOLEAN;
BEGIN
s:=Ltrim(s);
Empty:= Length(s) = 0;
END;


procedure TForm1.bSelectClick(Sender: TObject);
var f:textfile;
    s:string;
    return:boolean;
    d:integer;
begin
// this is the procedure that does all the work
doPause:=false;
doCancel:=true;
application.processmessages;

if opendialog1.execute
   then begin
        cFname.text:=opendialog1.filename;
        end;
end;

procedure TForm1.bStopClick(Sender: TObject);
begin
doPause:=true;
end;

procedure TForm1.bStartClick(Sender: TObject);
var f:textfile;
    s:string;
    return:boolean;
    d:integer;
begin
if empty(cFname.text)
   then begin
        Showmessage('Select a file of logged NMEA data first');
        exit;
        end;

// this is the procedure that does all the work
doPause:=false;
doCancel:=false;

// find the OziExplorer main window
hwnd1:= FindWindow('TfmMainform', nil);

// tell OziExplorer to stop moving map
return:= PostMessage(hwnd1, OziMessage, 210, 0);
delay(1000);
// tell OziExplorer to start moving map but get NMEA sentence from the clipboard
return:= PostMessage(hwnd1, OziMessage, 212, 0);

assignfile(f,cFname.text);
reset(f);

// loop until the log file is empty
while not eof(f)
do begin

   // if paused
   while doPause
     do begin
        delay(100);
        application.processmessages;
        if doCancel then break;
        end;

   //if cancelled
   if doCancel then break;

   // read the NMEA string from the log
   readln(f,s);

   if ((cNMEA.itemindex=0) and (pos('$GPRMC',s)=1)) or
      ((cNMEA.itemindex=1) and (pos('$GPGGA',s)=1)) or
      ((cNMEA.itemindex=2) and (pos('$GPGLL',s)=1)) or
      ((pos('$GPVTG',s)=1))
      then begin

   // put it on the clipboard
   Clipboard.Clear;
   form1.cGPSstring.text:=s;
   sleep(10);
   s:=s + #13 + #10;
   Clipboard.AsText:=s;
   // find the OziExplorer main window
   hwnd1:= FindWindow('TfmMainform', nil);
   If hwnd1<>0
      Then begin
           // tell OziExplorer that the sentence is ready on the clipboard
           return:= PostMessage(hwnd1, OziMessage, 202, 0);
           end;
   application.processmessages;

   //if its not the VTG message then delay
   if pos('$GPVTG',s)<>1
      then begin
           // wait for a while
           if empty(cDelay.text) then d:=500 else d:=strtoint(cDelay.text);
           delay(d);
           end;

   end;
   end;

closefile(f);
if doCancel then cGPSstring.text:='Cancelled'
            else cGPSstring.text:='File finished';

end;

procedure TForm1.bCancelClick(Sender: TObject);
begin
doCancel:=true;
end;

procedure TForm1.cNMEAClick(Sender: TObject);
begin
doPause:=false;
doCancel:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
doCancel:=true;
end;

end.

